import processing.serial.*;

Serial Port;
int y0=250;
int t=10;
int data_L,data_H,sign,data;
int anykey=0;
int degree=0;

void setup(){
  background(0);
  size(500,500);
  // angle-velocity register value axis
  stroke(204, 102, 0);
  line(10,250,500,250);
  line(10,0,10,500);
  line(0,50,20,50);
  line(0,450,20,450);
  textSize(10);
  text("AngleVelocity register",10,30);
  text("25",20,50);
  text("0",15,245);
  text("-25",20,450);
  // angle axis
  stroke(0, 102, 204);
  line(10,200,500,200);
  line(490,0,490,500);
  line(480,100,500,100);
  line(480,300,500,300);
  textSize(10);
  text("Angle[degree]",420,30);
  text("10degree",440,95);
  text("-10degree",430,295);
  text("t=0",12,490);
  text("t=240",460,490);
  Port = new Serial(this, "COM5", 9600);
  frameRate(2);
}

void plot_data( int data ) {
  stroke( 255, 0, 0 );
  strokeWeight( 2 );
  degree=degree+(data/2);
  point( t, y0-(data*5) );
  stroke( 0,255, 0 );
  point(t,200-(degree/114)*10);
  println(degree);
  println(data);
}

void draw(){
  plot_data( data );
  t = (t+1) % width;
  if (t == 480) {
    Port.write(66);
    noLoop();
  }
}

void serialEvent(Serial p) {
  if(Port.available()> 2) {
    data_L=Port.read();
    data_H=Port.read();
    sign=Port.read();
    data=(data_H<<8)+data_L;
    if (sign ==1) {
      data=-data;
    }
  }
//  println(data);
  if (anykey == 255) {
    Port.write(66);
  }
}

void mousePressed() {
  Port.clear();
  Port.write(65);
}

void keyPressed() {
   anykey = 255;
}

